#include <Wire.h>



void InitDisplay()
{
  
          Wire.beginTransmission(address);
        
        digitalWrite(Reset, LOW);   // Reset 
        delay(500);               // wait for a second
        digitalWrite(Reset, HIGH);    // 
        delay(500);               // wait for a second 
        
        Wire.write(initlcd,14);

      //Back light On
       error = Wire.endTransmission();
      
          if (error == 0)
          {
               digitalWrite(WorkBckLight, HIGH);    // turn the LED off by making the voltage LOW
          }
        Wire.endTransmission();

    }

//The End init

void gotoxy (int ax, int ay)
{
Wire.beginTransmission(address);

  gotoxylcd[2] = 0x40 + ay;
  gotoxylcd[3] = 0x80 + ax;

  Wire.write(gotoxylcd,4);
  
Wire.endTransmission();
       
}

void erase_x (int x)
{
  aa = 1;
}

void erase_y (int y)
{
  gotoxy(0,y); 
  Wire.beginTransmission(address);
  
  Wire.write(erase_ylcd,9);
  Wire.endTransmission();

}

void clear_screen (void)
{

for (aa= 0; aa < 98; aa++)
{
 for (bb = 0; bb <8; bb++) 
 {
  gotoxy(aa,bb); 
  Wire.beginTransmission(address);
  Wire.write(erase_ylcd,2);
  Wire.endTransmission();

 }
}

}

void LCD_Print(int x, int y, String Val) //Положение строки х и у, и строка для печати

{

      for (j=0; j<Val.length(); j++)
      {
          gotoxy((x+j)*6,y);//Устанавливаем курсор в позицию x и y, ширина символа 6 пикселей
          delay(10);
        
        Wire.beginTransmission(address);
        
          i2cData[0] = 0x40;
          i2cData[1] = 0x00;
        if (Val[j]>=0x20)
        {
          charpos=(Val[j]-0x20)*5;    // Вычисляем позицию символа в таблице 
        }
       
        else
        {
          charpos=(0x9f - 0x20)*5;    // Вычисляем позицию символа в таблице 
//          Serial.println(Val[j]);
 //         Serial.println(0x9f+ 0x20);
//          Serial.print("charpos, DEC  ");
//          Serial.println(charpos, DEC);
        }
        		// Table - the container for the character first 0x40v    end  0x00 1 byte (always blank)
          memcpy( &i2cData[1],&TABLE5[charpos],5); 	// fill the container codes
        
        Wire.write( i2cData,7);
        
        Wire.endTransmission();
      }

}


void Line(int x1, int y1, int x2, int y2, int w)
{
//дисплей 98х64 точки, где 8 строк по 98 столбцов в каждом. 
//поделим дисплей на квадраты 1 строка и 8 столбцов. Биты заполняются снизу вверх в строке
// y = ax + b

int a, b, x, y;

        a = (y2 - y1)/(x2 - x1);
        b = y1 - a * x1;

for (x = x1; x <= x2; x++)
    {
       
        y = round(a * x + b);
    
        gotoxy(x,y);  

      }


}

void Pointxy(int px, int py, int p)

{

  int  x, y, m = p, n;
  x = px;
  y = int(py/8);

  for (n = 1; n <= py-8*y; n++)
{
  m = m*2; 
}

  gotoxy(x, y);
  
  Wire.beginTransmission(address);

  i2cDot[0] = 0x40;
  
  i2cDot[1] = m;

  Wire.write(i2cDot,2);
        
  Wire.endTransmission();
}

